package com.contextspace.objectdb_example.model;

import java.util.ArrayList;
import java.util.List;

import javax.jdo.annotations.Index;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;


/**
 * Creation Details:
 * @author pedwards
 * Created: Jun 1, 2011
 * Time: 10:28:10 AM
 */
@Entity
@Index(members={"attributeList.name"})
public abstract class AbstractContactDetail extends IDHolder {

    private boolean primary;
    private List<Attribute> attributeList = new ArrayList<Attribute>();
    
    /**
     * @return the primary
     */
    @Column(name="isPrimary")
    public boolean getPrimary() {
        return primary;
    }

    /**
     * @param primary the primary to set
     */
    public void setPrimary(boolean primary) {
        this.primary = primary;
    }
    
    public List<Attribute> getAttribute(String name) {
        List<Attribute> resultAttributeList = new ArrayList<Attribute>();
        for(int i=0; i<attributeList.size(); i++) {
            Attribute attr = attributeList.get(i);
            if(attr.getName().equals(name)) {
                resultAttributeList.add(attr);
            }
        }
        return resultAttributeList;
    }
   
    public void addAttribute(Attribute attribute) {
        attributeList.add(attribute);
    }

    public void removeAttribute(String name) {
    
        for(int i = 0;i < attributeList.size(); i++) {
            if(attributeList.get(i).getName().equals(name)) {
                attributeList.remove(attributeList.get(i));
            }
        }   
    }
        
    /**
     * @param attributeToRemove
     */
    public void removeAttribute(Attribute attributeToRemove) {
        String name = attributeToRemove.getName();
        removeAttribute(name);
    }
    
    /**
     * @param attributeToReplace
     */
    public void replaceAttribute(Attribute attributeToReplace) {
        String name = attributeToReplace.getName();

        for(int i = 0;i < attributeList.size(); i++) {
            if(attributeList.get(i).getName().equals(name)) {
                attributeList.set(i, attributeToReplace);
            }
        }   
    }
    
    /**
     * Get the attributes as a list
     * @return
     */
    @OneToMany(cascade=CascadeType.ALL, fetch = FetchType.EAGER, orphanRemoval=true)
    @JoinColumn(name="OWNER_ID")
    public List<Attribute> getAttributeList() {
        return attributeList;
    }
    
    /**
     * Set the attribute map from a list
     * @param attrList
     */
    public void setAttributeList(List<Attribute> attrList) {
        attributeList = attrList;
    }
}
