package com.contextspace.objectdb_example.model;

import javax.persistence.Entity;

@Entity
public class ElectronicAddress extends AbstractContactDetail {

    public enum ElectronicType {
        AIM, Email, Google, Gizmo, ICQ, Jabber, MSN, SIP, Skype, Yahoo
    }
    
    private ElectronicType type;
    
    private String address;
    
    /**
     * Default Constructor
     */
    public ElectronicAddress() {
        
    }
    
    /**
     * Constructor taking type and its value
     * @param type
     * @param value
     */
    public ElectronicAddress(ElectronicType type, String address) {
        this.type = type;
        this.address = address;
    }
    
    /**
     * @return the type
     */
    public ElectronicType getType() {
        return type;
    }

    /**
     * @param type the type to set
     */
    public void setType(ElectronicType type) {
        this.type = type;
    }

    /**
     * @return the value
     */
    public String getAddress() {
        return address;
    }

    /**
     * @param value the value to set
     */
    public void setAddress(String address) {
        this.address = address;
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("<electronicAddress type=\"").append(type).append("\" address=\"").append(address).append("\"");
        buf.append(super.toString());        
        buf.append("</electronicAddress>");
        return buf.toString();
    }
    
}
